-- dlla2.e --- Versi baru penangan dll
-- update 25 6 03 21:03, ga keluar eror kalo belom DIPAKE, pake HASH lebih bagus
--
-- dllID: -1 = routine ga ada, -2 = file dll ga ada, -3 = nama dicari ga ada

without warning

include dll.e
include aku.e

global constant --asli
	cChar = #01000001,
	cUChar = #02000001,
	cShort = #01000002,
	cUShort = #02000002,
	cInt = #01000004,
	cUInt = #02000004,
	cLong = C_INT,
	cULong = C_UINT,
	cPtr = C_ULONG,
	cFloat = #03000004,
	cSingle = cFloat,
	cDouble = #03000008

global constant --tambahan
	cpStr  = #3F000014,
	cpLong = #3F000024

constant UK_HASH = 50

object ddd
ddd = repeat({}, UK_HASH)

global object dllPar -- kembalian
dllPar = {}

function hash(object st)
object hs
	hs = 0
	for i = 1 to length(st) do
		hs += st[i] * i
	end for
	hs = sisa(hs, UK_HASH)
	return hs+1
end function

constant efdll = 1, enama = 2, eparj = 3, ebal = 4, eid = 5, ejenis = 6,
jproc = 1, jfunc = 2

function parjkeparj2(object parj)
	for i = 1 to length(parj) do
		if parj[i] >= #3F000000 then
			parj[i] = cPtr
		end if
	end for
	return parj
end function

procedure kacau(object st)
object x
	puts(2, "ERROR " & st & "\n")
	x = isist("There was an error. Type yes to continue the program or no to abort.")
	if find('y', x) or find('Y', x) then
		-- lanjut!
	else
		abort(200)
	end if
end procedure

procedure tambahEntri(object entri)
object hashPos
	hashPos = hash(entri[enama])
	ddd[hashPos] = append(ddd[hashPos], entri)
end procedure

function cariEntri(object nama)
object hashPos
	hashPos = hash(nama)
	for i = 1 to length(ddd[hashPos]) do
		if equal(ddd[hashPos][i][enama], nama) then
			return ddd[hashPos][i]
		end if
	end for
	return -3
end function

global procedure dllBaru(object fdll, object nama, object parj, object bal)
object ret, parj2, alias, entri

	alias = ""
	if length(nama) = 2 and sequence(nama[1]) then
		alias = nama[1]
		nama = nama[2]
	end if
	
	entri = {fdll, nama, parj, bal, -1, kalo(bal, jfunc, jproc)}
	
	ret = open_dll(fdll)
	if ret <= 0 then
		entri[eid] = -2 -- ga ada file dll
		tambahEntri(entri)
		return
	end if
	
	parj2 = parjkeparj2(parj)
	if entri[ejenis] = jproc then
		entri[eid] = define_c_proc(ret, nama, parj2)
	else
		entri[eid] = define_c_func(ret, nama, parj2, bal)
	end if
	
	tambahEntri(entri)
	
	if length(alias) then
		entri[enama] = alias
		tambahEntri(entri)
	end if
end procedure

global function dllID(object nama)
object ret
	ret = cariEntri(nama)
	if atom(ret) then
		return ret
	else
		return ret[eid]
	end if
end function

global function dllFunc(object nama, object par)
object entri, tp, hasil, stlen, parj
	
	entri = cariEntri(nama)
	if atom(entri) then
		kacau("dllFunc: dll routine name not found! nama = " & euob(nama) & " par = " & euob(par))
		return 0
	end if

	parj = entri[eparj]
	stlen = repeat(0, length(parj))
	for i = 1 to length(parj) do
		if parj[i] = cpStr then
			if sequence(par[i]) then
				stlen[i] = length(par[i])
				par[i] = allocate_string(par[i])
				if par[i] <= 0 then
					kacau("dllFunc: cannot allocate_string! i = " & euob(i))
					return 0
				end if
			end if
		elsif parj[i] = cpLong then
			tp = par[i]
			par[i] = allocate(4)
			poke4(par[i], tp)
		end if
	end for
	
	if entri[eid] < 0 then
		kacau("dllFunc: id less than 0! entri[eid] = " & euob(entri[eid]) & " nama = " & euob(nama))
		return 0
	end if
	
	if entri[ejenis] = jproc then
		c_proc(entri[eid], par)
		hasil = 0
	else
		hasil = c_func(entri[eid], par)
	end if

	for i = 1 to length(parj) do
		if parj[i] = cpStr then
			tp = par[i]
			par[i] = peek({par[i], stlen[i]})
			if stlen[i] then
				free(tp)
			end if
		elsif parj[i] = cpLong then
			tp = par[i]
			par[i] = peek4s(par[i])
			free(tp)
		end if
	end for

	dllPar = par
	
	return hasil
end function

global procedure dllProc(object nama, object par)
	PP = dllFunc(nama, par)
end procedure
