-- keyboardlock.e
-- aku 2003

include dlla2.e

object keyState
keyState = allocate(256)

dllBaru("user32", "GetKeyboardState", {cPtr}, cLong)

constant VK_NUMLOCK = #90
constant VK_SCROLL  = #91
constant VK_CAPITAL = #14

procedure getKeyState()
	dllProc("GetKeyboardState", {keyState})
end procedure

global function getNumLock()
	getKeyState()
	return peek(keyState + VK_NUMLOCK)
end function

global function getCapsLock()
	getKeyState()
	return peek(keyState + VK_CAPITAL)
end function

global function getScrollLock()
	getKeyState()
	return peek(keyState + VK_SCROLL)
end function

